var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import { diff } from "./utils";
var FlattenPriorityGroup = (function (_super) {
    __extends(FlattenPriorityGroup, _super);
    function FlattenPriorityGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.queue = [];
        _this.add = function (cb, _a, ref) {
            var _b = _a.priority, priority = _b === void 0 ? 0xFFFFFF : _b, _c = _a.shift, shift = _c === void 0 ? 0 : _c;
            var q = {
                cb: cb,
                ref: ref,
                priority: priority,
                shift: shift,
                index: _this.queue.length,
            };
            q.sortIndex = q.index + q.shift;
            _this.queue.push(q);
            _this.update();
            return q;
        };
        _this.remove = function (q) {
            var index = _this.queue.indexOf(q);
            if (index > 0) {
                _this.queue.splice(index, 1);
                _this.props.channel.remove(q.q);
            }
        };
        _this.replace = function (q, cb, _a, ref) {
            var _b = _a.priority, priority = _b === void 0 ? 0xFFFFFF : _b, _c = _a.shift, shift = _c === void 0 ? 0 : _c;
            if (q) {
                var changedPriority = q.priority !== priority || q.shift !== q.shift;
                var changedRef = q.ref !== ref;
                q.cb = cb;
                q.priority = priority;
                q.shift = shift;
                q.sortIndex = q.index + q.shift;
                q.ref = ref;
                if (changedPriority || changedRef) {
                    q.update = true;
                    _this.update();
                }
            }
            return q;
        };
        _this.reset = function () {
            _this.props.channel.reset();
        };
        _this.schedule = function (ref, cb) {
            _this.props.channel.schedule(ref, cb);
        };
        _this.channel = {
            add: _this.add,
            remove: _this.remove,
            replace: _this.replace,
            reset: _this.reset,
            schedule: _this.schedule,
        };
        return _this;
    }
    FlattenPriorityGroup.prototype.componentDidUpdate = function (oldProps) {
        if (oldProps.disabled && !this.props.disabled) {
            this.update();
        }
    };
    FlattenPriorityGroup.prototype.update = function () {
        var _this = this;
        if (this.props.disabled) {
            return;
        }
        var _a = this.props, channel = _a.channel, _b = _a.shift, shift = _b === void 0 ? 0 : _b, blockPriority = _a.priority;
        channel.schedule(this, function () {
            _this.sortQ();
            _this.queue.forEach(function (q, index) {
                if (q.index0 !== index || q.update || !q.q) {
                    var cb = q.cb, index0 = q.index0, ref = q.ref, qPriority = q.priority;
                    var priority = qPriority < Infinity ? blockPriority : qPriority;
                    q.update = false;
                    if (q.q) {
                        channel.replace(q.q, cb, { priority: priority, shift: index0 - index + shift }, ref);
                    }
                    else {
                        q.q = channel.add(q.cb, { priority: priority, shift: shift }, ref);
                        q.index0 = index;
                    }
                }
            });
        });
    };
    FlattenPriorityGroup.prototype.sortQ = function () {
        var _this = this;
        if (this.props.source) {
            this.queue.forEach(function (q) { return q.sortOrder = q.priority < Infinity ? _this.props.source(q) : q.priority; });
        }
        else {
            this.queue.forEach(function (q) { return q.sortOrder = q.priority; });
        }
        if (this.props.reverse) {
            this.queue.sort(function (a, b) { return diff(b, a); });
        }
        else {
            this.queue.sort(function (a, b) { return diff(a, b); });
        }
    };
    FlattenPriorityGroup.prototype.render = function () {
        return this.props.children(this.channel);
    };
    return FlattenPriorityGroup;
}(React.Component));
export { FlattenPriorityGroup };
